/*
 * (c) Sinelabore Software Tools GmbH, 2008 - 2022
 *
 * All rights reserved. Reproduction, modification,
 * use or disclosure to third parties without express
 * authority is forbidden.
 */

/* Command line options: C:\Users\T440s-User\develop\workspace\dcf77\dcf77_decoder\decoder.xml   */
/* This file is generated from decoder.xml - do not edit manually  */
/* Generated on: Sat Jan 21 14:08:05 CET 2023 / Version 5.5.6.3486 */


#include <stdint.h>
#include <stdbool.h>
#include "../own_decoder_event.h"
#include "decoder_ext.h"
#include "decoder.h"
#include "../pulse_len.h"

uint8_t invalidFlag, secCnt, bitpos;
uint8_t minute, hour, day, dayOfWeek, month, year;

extern uint8_t setClock(uint8_t minute, uint8_t hour,
                        uint8_t day, uint8_t dayOfWeek,
                        uint8_t month, uint8_t year);

uint8_t update(PULSE_LEN_T len, uint8_t in){
  if(len==LONG) in=in|bitpos;
  bitpos=bitpos<<1;
  return in;
}

void setTimeToZero(void){
  minute=0;
  hour=0;
  day=0;
  dayOfWeek=0;
  month=0;
  year=0;
}




void  decoder(DECODER_INSTANCEDATA_T *instanceVar, OWN_DECODER_EVENT_T *userData){

	DECODER_EV_CONSUMED_FLAG_T evConsumed = 0U;

	
	/*execute entry code of default state once to init machine */
	if(instanceVar->waitforminstartEntry==1U){
		invalidFlag=1;
		

		instanceVar->waitforminstartEntry=0U;
	}


	switch (instanceVar->stateVar) {

		case MinDetected:

			switch (instanceVar->stateVarMinDetected) {

				case Day:
					if(userData->msg==(DECODER_EVENT_T)evTick){
						if(secCnt<=41){
							/* Transition from Day to Day */
							evConsumed=1U;

							/* Action code for transition  */
							day=update(userData->len, day);
							secCnt++;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Day;
						}else{
							/* Transition from Day to DayOfWeek */
							evConsumed=1U;

							/* Action code for transition  */
							day=update(userData->len, day);
							secCnt++;
							bitpos=1;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = DayOfWeek;
						} /*end of event selection */
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case Day  */

				case DayOfWeek:
					if(userData->msg==(DECODER_EVENT_T)evTick){
						if(secCnt<=44){
							/* Transition from DayOfWeek to DayOfWeek */
							evConsumed=1U;

							/* Action code for transition  */
							dayOfWeek=update(userData->len, dayOfWeek);
							secCnt++;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = DayOfWeek;
						}else{
							/* Transition from DayOfWeek to Month */
							evConsumed=1U;

							/* Action code for transition  */
							dayOfWeek=update(userData->len, dayOfWeek);
							secCnt++;
							bitpos=1;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Month;
						} /*end of event selection */
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case DayOfWeek  */

				case Hour:
					if(userData->msg==(DECODER_EVENT_T)evTick){
						if(secCnt<=35){
							/* Transition from Hour to Hour */
							evConsumed=1U;

							/* Action code for transition  */
							hour=update(userData->len, hour);
							secCnt++;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Hour;
						}else{
							/* Transition from Hour to Day */
							evConsumed=1U;

							/* Action code for transition  */
							hour=update(userData->len, hour);
							secCnt++;
							bitpos=1;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Day;
						} /*end of event selection */
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case Hour  */

				case IgnoreBBKMeteo:
					if(userData->msg==(DECODER_EVENT_T)evTick){
						if(secCnt==21){
							/* Transition from IgnoreBBKMeteo to Minute */
							evConsumed=1U;

							/* Action code for transition  */
							secCnt++;
							bitpos=1;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Minute;
						}else{
							/* Transition from IgnoreBBKMeteo to IgnoreBBKMeteo */
							evConsumed=1U;

							/* Action code for transition  */
							secCnt++;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = IgnoreBBKMeteo;
						} /*end of event selection */
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case IgnoreBBKMeteo  */

				case Minute:
					if(userData->msg==(DECODER_EVENT_T)evTick){
						if(secCnt<=28){
							/* Transition from Minute to Minute */
							evConsumed=1U;

							/* Action code for transition  */
							minute = update(userData->len, minute);
							secCnt++;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Minute;
						}else{
							/* Transition from Minute to Hour */
							evConsumed=1U;

							/* Action code for transition  */
							minute=update(userData->len, minute);
							secCnt++;
							bitpos=1;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Hour;
						} /*end of event selection */
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case Minute  */

				case Month:
					if(userData->msg==(DECODER_EVENT_T)evTick){
						if(secCnt<=49){
							/* Transition from Month to Month */
							evConsumed=1U;

							/* Action code for transition  */
							month=update(userData->len, month);
							secCnt++;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Month;
						}else{
							/* Transition from Month to Year */
							evConsumed=1U;

							/* Action code for transition  */
							month=update(userData->len, month);
							secCnt++;
							bitpos=1;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Year;
						} /*end of event selection */
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case Month  */

				case Year:
					if(userData->msg==(DECODER_EVENT_T)evTick){
						if(secCnt<59){
							/* Transition from Year to Year */
							evConsumed=1U;

							/* Action code for transition  */
							year=update(userData->len, year);
							secCnt++;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = Year;
						}else{
							/* Transition from Year to IgnoreBBKMeteo */
							evConsumed=1U;

							/* Action code for transition  */
							invalidFlag = setClock(minute, hour, day, dayOfWeek, month, year);
							setTimeToZero();
							secCnt=0x1;



							/* adjust state variables  */
							instanceVar->stateVarMinDetected = IgnoreBBKMeteo;
						} /*end of event selection */
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case Year  */

				default:
					/* Intentionally left blank */
				break;
			} /* end switch MinDetected */

			/* Check if event was already processed  */
			if(evConsumed==0U){

				if(userData->msg==(DECODER_EVENT_T)evTimingError){
					/* Transition from MinDetected to WaitForMinStart */
					evConsumed=1U;
					
					/* OnEntry code of state WaitForMinStart */
					invalidFlag=1;

					/* adjust state variables  */
					instanceVar->stateVar = WaitForMinStart;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			}
		break; /* end of case MinDetected  */

		case WaitForMinStart:
			if(userData->msg==(DECODER_EVENT_T)evMinStart){
				/* Transition from WaitForMinStart to MinDetected */
				evConsumed=1U;

				/* Action code for transition  */
				secCnt=0x1;
				setTimeToZero();


				instanceVar->stateVar = MinDetected;/* Default in entry chain  */
				instanceVar->stateVarMinDetected = IgnoreBBKMeteo;/* Default in entry chain  */

			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		break; /* end of case WaitForMinStart  */

		default:
			/* Intentionally left blank */
		break;
	} /* end switch stateVar_root */
}

/* Implementation of the reset machine function */
void decoderResetMachine(DECODER_INSTANCEDATA_T * const instanceVar){
	instanceVar->waitforminstartEntry = 1U;
	instanceVar->stateVar = WaitForMinStart;
	instanceVar->stateVarMinDetected = IgnoreBBKMeteo;

}
// Helper(s) to reset history
void decoderResetHistoryMinDetected(DECODER_INSTANCEDATA_T * const instanceVar){
	instanceVar->stateVarMinDetected=IgnoreBBKMeteo;
}


// Helper(s) to find out if the machine is in a certain state

uint8_t decoderIsInDay(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVarMinDetected== Day)&&(instanceVar->stateVar== MinDetected)) ? (1U) : (0U));
}

uint8_t decoderIsInDayOfWeek(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVarMinDetected== DayOfWeek)&&(instanceVar->stateVar== MinDetected)) ? (1U) : (0U));
}

uint8_t decoderIsInHour(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVarMinDetected== Hour)&&(instanceVar->stateVar== MinDetected)) ? (1U) : (0U));
}

uint8_t decoderIsInIgnoreBBKMeteo(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVarMinDetected== IgnoreBBKMeteo)&&(instanceVar->stateVar== MinDetected)) ? (1U) : (0U));
}

uint8_t decoderIsInMinDetected(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVar== MinDetected)) ? (1U) : (0U));
}

uint8_t decoderIsInMinute(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVarMinDetected== Minute)&&(instanceVar->stateVar== MinDetected)) ? (1U) : (0U));
}

uint8_t decoderIsInMonth(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVarMinDetected== Month)&&(instanceVar->stateVar== MinDetected)) ? (1U) : (0U));
}

uint8_t decoderIsInWaitForMinStart(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVar== WaitForMinStart)) ? (1U) : (0U));
}

uint8_t decoderIsInYear(const DECODER_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVarMinDetected== Year)&&(instanceVar->stateVar== MinDetected)) ? (1U) : (0U));
}


// Helper to get id of innermost active state
DECODER_STATES_T decoderGetInnermostActiveState(const DECODER_INSTANCEDATA_T * const instanceVar){
	DECODER_STATES_T innermost;

	if(decoderIsInYear(instanceVar)){
		innermost =Year;
	}else if(decoderIsInMonth(instanceVar)){
		innermost = Month;
	}else if(decoderIsInMinute(instanceVar)){
		innermost = Minute;
	}else if(decoderIsInIgnoreBBKMeteo(instanceVar)){
		innermost = IgnoreBBKMeteo;
	}else if(decoderIsInHour(instanceVar)){
		innermost = Hour;
	}else if(decoderIsInDayOfWeek(instanceVar)){
		innermost = DayOfWeek;
	}else if(decoderIsInDay(instanceVar)){
		innermost = Day;
	}else if(decoderIsInWaitForMinStart(instanceVar)){
		innermost = WaitForMinStart;
	}else{
		innermost = __DECODER_LAST_STATE__;
	}
	return innermost;}

