/*
 * (c) Sinelabore Software Tools GmbH, 2008 - 2022
 *
 * All rights reserved. Reproduction, modification,
 * use or disclosure to third parties without express
 * authority is forbidden.
 */

/* Command line options: C:\Users\T440s-User\develop\workspace\dcf77\dcf77_decoder\decoder.xml   */
/* This file is generated from decoder.xml - do not edit manually*/
/* Generated on: Sat Jan 21 14:08:05 CET 2023 / Version 5.5.6.3486 */


#ifndef DECODER_H
#define DECODER_H


/* Header to define simple data types */
#include <stdint.h>
#include <stdbool.h>

/* State definitions */
typedef enum{
	Day,
	DayOfWeek,
	Hour,
	IgnoreBBKMeteo,
	MinDetected,
	Minute,
	Month,
	WaitForMinStart,
	Year,
	__DECODER_LAST_STATE__} DECODER_STATES_T;






/* Predefined types required by the codegen. You can provide your own  */
/* definitions by setting the following define somewhere in your built env. */
#ifndef PROVIDE_OWN_DECODER_STATEMACHINE_TYPES
	typedef uint8_t DECODER_ENTRY_FLAG_T;
	typedef DECODER_STATES_T DECODER_STATEVAR_T;
	typedef uint8_t DECODER_INST_ID_T;
	typedef uint8_t DECODER_EV_CONSUMED_FLAG_T ;
#endif




/* Instance data definition of state machine */
typedef struct{
	DECODER_ENTRY_FLAG_T waitforminstartEntry;
	DECODER_STATEVAR_T stateVar;
	DECODER_STATEVAR_T stateVarMinDetected;

	/* Start of user defined attributes */
	/* End of user defined attributes */

	DECODER_INST_ID_T inst_id;
} DECODER_INSTANCEDATA_T;

/* Helper to initialize the machine's instance data */
#define DECODER_INSTANCEDATA_INIT {\
	1,\
	(DECODER_STATEVAR_T) WaitForMinStart /* set init state of top state */,\
	(DECODER_STATEVAR_T) IgnoreBBKMeteo /* set init state of MinDetected */,\
	0 /* instance id */ } 


/* Helper(s) to reset history */
#define DECODER_RESET_HISTORY_MINDETECTED(instance) ((&(instance))->stateVarMinDetected=IgnoreBBKMeteo)

/*Prototype of the state machine function */
void  decoder(DECODER_INSTANCEDATA_T *instanceVar, OWN_DECODER_EVENT_T *userData);


/*Prototoye of the reset machine function */
void decoderResetMachine(DECODER_INSTANCEDATA_T * const instanceVar);

/* Helper(s) to reset history */
void decoderResetHistoryMinDetected(DECODER_INSTANCEDATA_T * const instanceVar);

/* Helper(s) to find out if the machine is in a certain state*/
uint8_t decoderIsInDay(const DECODER_INSTANCEDATA_T * const instanceVar);
uint8_t decoderIsInDayOfWeek(const DECODER_INSTANCEDATA_T * const instanceVar);
uint8_t decoderIsInHour(const DECODER_INSTANCEDATA_T * const instanceVar);
uint8_t decoderIsInIgnoreBBKMeteo(const DECODER_INSTANCEDATA_T * const instanceVar);
uint8_t decoderIsInMinDetected(const DECODER_INSTANCEDATA_T * const instanceVar);
uint8_t decoderIsInMinute(const DECODER_INSTANCEDATA_T * const instanceVar);
uint8_t decoderIsInMonth(const DECODER_INSTANCEDATA_T * const instanceVar);
uint8_t decoderIsInWaitForMinStart(const DECODER_INSTANCEDATA_T * const instanceVar);
uint8_t decoderIsInYear(const DECODER_INSTANCEDATA_T * const instanceVar);


/* Macros to test if the machine is in a certain state. */
#define DECODER_IS_IN_DAY(instance)((((&instance)->stateVarMinDetected==Day)&&((&instance)->stateVar==MinDetected)) ? (1U) : (0U))
#define DECODER_IS_IN_DAYOFWEEK(instance)((((&instance)->stateVarMinDetected==DayOfWeek)&&((&instance)->stateVar==MinDetected)) ? (1U) : (0U))
#define DECODER_IS_IN_HOUR(instance)((((&instance)->stateVarMinDetected==Hour)&&((&instance)->stateVar==MinDetected)) ? (1U) : (0U))
#define DECODER_IS_IN_IGNOREBBKMETEO(instance)((((&instance)->stateVarMinDetected==IgnoreBBKMeteo)&&((&instance)->stateVar==MinDetected)) ? (1U) : (0U))
#define DECODER_IS_IN_MINDETECTED(instance)((((&instance)->stateVar==MinDetected)) ? (1U) : (0U))
#define DECODER_IS_IN_MINUTE(instance)((((&instance)->stateVarMinDetected==Minute)&&((&instance)->stateVar==MinDetected)) ? (1U) : (0U))
#define DECODER_IS_IN_MONTH(instance)((((&instance)->stateVarMinDetected==Month)&&((&instance)->stateVar==MinDetected)) ? (1U) : (0U))
#define DECODER_IS_IN_WAITFORMINSTART(instance)((((&instance)->stateVar==WaitForMinStart)) ? (1U) : (0U))
#define DECODER_IS_IN_YEAR(instance)((((&instance)->stateVarMinDetected==Year)&&((&instance)->stateVar==MinDetected)) ? (1U) : (0U))


/* Helper returning the innermost active state.*/
DECODER_STATES_T decoderGetInnermostActiveState(const DECODER_INSTANCEDATA_T * const instanceVar);

#endif
