/*
 * (c) Sinelabore Software Tools GmbH, 2008 - 2022
 *
 * All rights reserved. Reproduction, modification,
 * use or disclosure to third parties without express
 * authority is forbidden.
 */

/* Command line options: C:\Users\T440s-User\develop\workspace\dcf77\dcf77_irq\dcf77_irq.xml   */
/* This file is generated from dcf77_irq.xml - do not edit manually  */
/* Generated on: Sat Jan 21 14:11:20 CET 2023 / Version 5.5.6.3486 */


#include <msp430.h> 
#include <stdint.h>
#include "dcf77_irq_ext.h"
#include "../pulse_len.h"
#include "dcf77_irq.h"
#include "../dcf77_decoder/decoder_ext.h"


// irq cycle time 3.8ms
#define SHORT_MIN 0x17  //
#define SHORT_MAX 0x22  //
#define LONG_MIN 0x30   //
#define LONG_MAX 0x3A   //
#define MIN_START 250




void  dcf77_irq(DCF77_IRQ_INSTANCEDATA_T *instanceVar){
	
	/*execute entry code of default state once to init machine */
	if(instanceVar->wait_low_min_startEntry==1U){
		if((P1IN & 1U)==1U){
			P1OUT |= 0x02;
			
			instanceVar->stateVar = WAIT_HIGH_MIN_START;
		}else{
			P1OUT &= ~(0x02);
			
			instanceVar->stateVar = WAIT_LOW_MIN_START;
		}

		instanceVar->wait_low_min_startEntry=0U;
	}

	/* action code */
	instanceVar->msg = DECODER_NO_MSG;


	switch (instanceVar->stateVar) {

		case HIGH:
			/* action code  */
			instanceVar->cnt++;


			if((P1IN & 0x1U) == 0U){
				if((instanceVar->cnt >= LONG_MIN) &&
(instanceVar->cnt <= LONG_MAX)){
					/* Transition from HIGH to LOW */

					/* Action code for transition  */
					instanceVar->msg=evTick;
					instanceVar->len=LONG;


					/* OnEntry code of state LOW */
					instanceVar->cnt=0U;
					P1OUT &= ~(0x02);

					/* adjust state variables  */
					instanceVar->stateVar = LOW;
				}else if((instanceVar->cnt >= SHORT_MIN) &&
(instanceVar->cnt <= SHORT_MAX)){
					/* Transition from HIGH to LOW */

					/* Action code for transition  */
					instanceVar->msg=evTick;
					instanceVar->len=SHORT;


					/* OnEntry code of state LOW */
					instanceVar->cnt=0U;
					P1OUT &= ~(0x02);

					/* adjust state variables  */
					instanceVar->stateVar = LOW;
				}else{
					/* Transition from HIGH to WAIT_LOW_MIN_START */

					/* Action code for transition  */
					instanceVar->msg=evTimingError;
					instanceVar->cntTimingError++;
					instanceVar->cnt=0U;


					/* OnEntry code of state WAIT_LOW_MIN_START */
					P1OUT &= ~(0x02);

					/* adjust state variables  */
					instanceVar->stateVar = WAIT_LOW_MIN_START;
				} /*end of event selection */
			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		break; /* end of case HIGH  */

		case LOW:
			/* action code  */
			instanceVar->cnt++;


			if(P1IN & 0x1U){
				/* Transition from LOW to HIGH */

				/* OnEntry code of state HIGH */
				instanceVar->cnt=0;
				P1OUT |= 0x02;

				/* adjust state variables  */
				instanceVar->stateVar = HIGH;
			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		break; /* end of case LOW  */

		case WAIT_LOW_MIN_START:
			/* action code  */
			instanceVar->cnt++;


			if((P1IN & 0x1) == 1U){
				/* Transition from WAIT_LOW_MIN_START to WAIT_HIGH_MIN_START */

				/* OnEntry code of state WAIT_HIGH_MIN_START */
				P1OUT |= 0x02;

				/* adjust state variables  */
				instanceVar->stateVar = WAIT_HIGH_MIN_START;
			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		break; /* end of case WAIT_LOW_MIN_START  */

		case WAIT_HIGH_MIN_START:
			if((P1IN & 0x1) == 0U){
				/* Transition from WAIT_HIGH_MIN_START to WAIT_LOW_MIN_START */

				/* Action code for transition  */
				instanceVar->cnt=0;


				/* OnEntry code of state WAIT_LOW_MIN_START */
				P1OUT &= ~(0x02);

				/* adjust state variables  */
				instanceVar->stateVar = WAIT_LOW_MIN_START;
			}else if((instanceVar->cnt)>=MIN_START){
				/* Transition from WAIT_HIGH_MIN_START to HIGH */

				/* Action code for transition  */
				instanceVar->msg=evMinStart;


				/* OnEntry code of state HIGH */
				instanceVar->cnt=0;
				P1OUT |= 0x02;

				/* adjust state variables  */
				instanceVar->stateVar = HIGH;
			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		break; /* end of case WAIT_HIGH_MIN_START  */

		default:
			/* Intentionally left blank */
		break;
	} /* end switch stateVar_root */
}

/* Implementation of the reset machine function */
void dcf77_irqResetMachine(DCF77_IRQ_INSTANCEDATA_T * const instanceVar){
	instanceVar->wait_low_min_startEntry = 1U;
	instanceVar->stateVar = WAIT_LOW_MIN_START;
	
}

// Helper(s) to find out if the machine is in a certain state

uint8_t dcf77_irqIsInHIGH(const DCF77_IRQ_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVar== HIGH)) ? (1U) : (0U));
}

uint8_t dcf77_irqIsInLOW(const DCF77_IRQ_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVar== LOW)) ? (1U) : (0U));
}

uint8_t dcf77_irqIsInWAIT_HIGH_MIN_START(const DCF77_IRQ_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVar== WAIT_HIGH_MIN_START)) ? (1U) : (0U));
}

uint8_t dcf77_irqIsInWAIT_LOW_MIN_START(const DCF77_IRQ_INSTANCEDATA_T * const instanceVar){
	return(((instanceVar->stateVar== WAIT_LOW_MIN_START)) ? (1U) : (0U));
}


// Helper to get id of innermost active state
DCF77_IRQ_STATES_T dcf77_irqGetInnermostActiveState(const DCF77_IRQ_INSTANCEDATA_T * const instanceVar){
	DCF77_IRQ_STATES_T innermost;

	if(dcf77_irqIsInWAIT_LOW_MIN_START(instanceVar)){
		innermost =WAIT_LOW_MIN_START;
	}else if(dcf77_irqIsInWAIT_HIGH_MIN_START(instanceVar)){
		innermost = WAIT_HIGH_MIN_START;
	}else if(dcf77_irqIsInLOW(instanceVar)){
		innermost = LOW;
	}else if(dcf77_irqIsInHIGH(instanceVar)){
		innermost = HIGH;
	}else{
		innermost = __DCF77_IRQ_LAST_STATE__;
	}
	return innermost;}

